<?php
/**
 * Debug on/off
 *
 */
define("DEBUG",0);
$query_counter=0;

/**
 * MySQL database working class
 *
 */
class MySQLDB
{
	var $connection;
	var $last_query_num = 0;
	var $db_config = array();
	
	/**
	 * last query result id
	 *
	 * @var MySQL result
	 */
	 var $lastresult;
	/**
	 * last query assoc value
	 *
	 * @var bool
	 */
	 var $assoc = true;
	
	/**
	 * Initialises connection with MySQL database server and selects needed db
	 *
	 * @param MySQL Connection Id $connection
	 * @return MySQLDB
	 */
	function MySQLDB($connection=false)
	{
		if($connection)
			$this->connection=$connection;
		else
		{
			if(!($this->db_config = @parse_ini_file('config/'.'mysql.ini')))
			{
				print(('Cannot load mysql configuration'));
				return false;
			}

			if(!extension_loaded('mysql'))
			{
				print(('Unable to load module for database server "mysql": PHP mysql extension not available!'));
				return false;
			}

			$this->connection = @mysql_connect($this->db_config['server'], $this->db_config['username'], $this->db_config['password']);
		}

		if(empty($this->connection))
		{
			print(('Unable to connect to database server!'));
			return false;
		}
		else if(!@mysql_select_db($this->db_config['db'], $this->connection))
		{
			$this->db_error();
			return false;
		}
		
		mysql_query ("set character_set_client='cp1251'"); 
		mysql_query ("set character_set_results='cp1251'"); 
		mysql_query ("set collation_connection='cp1251_general_ci'");
		
		return true;
	}
	
	/**
	 * Executes query and returns result identifier
	 *
	 * @param string $query
	 * @return MySQL result
	 */
	 function query($query) 
	{
		// use escape/vf function for input data.
		//print('<textarea rows="5" cols="70">'.$query.'</textarea><br>');
		$result = @mysql_query($query, $this->connection) or $this->db_error(0, $query);
		$this->last_query_num++;
		return $result;
	}
	
	//      mysqlcommand (MySQL Connector 4 .NET):)
	/**
	 * Executes query and makes abstract data read available
	 *
	 * @param string $query
	 * @param bool $assoc
	 */
	function ExecuteReader($query,$assoc = true)
	{
		$this->lastresult = $this->query($query);
		$this->assoc=$assoc;		
	}
	
	/**
	 * Link to query method
	 *
	 * @param string $query
	 * @return MySQL result
	 */
	function ExecuteNonQuery($query)
	{
		$result = $this->query($query);
		return (mysql_affected_rows()==0 ? false : $result);	
	}
	
	/**
	 * Returns array with from the current query result
	 *
	 * @return array
	 */
	function Read()
	{
		if($this->assoc)
		{
			$result = @mysql_fetch_assoc($this->lastresult) or false;
		}
		else
		{
			$result = @mysql_fetch_row($this->lastresult) or false;
		}
		return $result;
	}
	
	
	/**
	 * Returns one row from the current query result
	 *
	 * @param int $row
	 * @return string
	 */
	function ReadSingleRow($row)
	{
		return mysql_result($this->lastresult,$row) or false;
	}

	/**
 	* Prints MySQL error message; swithing DEBUG, prints MySQL error description or sends it to administrator
 	*
 	*/
	function db_error($show=0,$query='')
	{
		global $system;
		if(!in_array(mysql_errno(),array(1062,1065,1191))) // Errcodes in array are handled at another way :)
		{
			if(DEBUG==1 || $show==1)
			{
				$warning='<br><b>'.('MySQL Error').':</b><br><i>';
				$warning.=mysql_errno().' : '.mysql_error().(empty($query) ? '</i>' : '<br>In query: <textarea cols="50" rows="7">'.$query.'</textarea></i>');
				print($warning) or print($warning);
			}
			else
			{
				print('An error occured. Please, try again later. Thank You !');
				$message.=mysql_errno().':'.mysql_error()."\r\n";
				$message.=(empty($query) ? '' : "In query: \r\n".$query."\r\n");
				rcms_log_put('MySQL error',$system->user['username'],$message);
			}
		}
	}
	
	/**
	 * Escapes string to use in SQL query
	 *
	 * @param string $string
	 * @return string
	 */
	function escape($string)
	{
		if (!get_magic_quotes_gpc()) 
	    	return mysql_real_escape_string($string,$this->connection);
		else
    		return mysql_real_escape_string(stripslashes($string),$this->connection);
	}
	
	/**
	 * Disconnects from database server
	 *
	 */
	function disconnect() 
	{
		@mysql_close($this->connection);
	}
}

/**
 * Returns cutted down entry data
 *
 * @param string $data
 * @param int $mode
 * @return string
 */
function vf($data,$mode=0)
{
	switch ($mode)
	{
		case 1:
			return ereg_replace("[^a-z0-9A-Z]",'',$data); // , 
			break;
		case 2:
			return ereg_replace("[^a-zA-Z]",'',$data); // 
			break;
		case 3:
			return ereg_replace("[^0-9]",'',$data); // 
			break;
		case 4:
			return ereg_replace("[^a-z0-9A-Z\-_\.]",'',$data); // , , , , 
			break;
		case 5:
			return ereg_replace("[^ [:punct:]".('a-zA-Z')."0-9]",'',$data); // .    +    
			break;
		default:
			return ereg_replace("[~@\+\?\%\/\;=\*\>\<\"\'\-]",'',$data); // -   .
			break;
	}
}



// function that executing query and returns array
function simple_queryall($query) {
global $query_counter;
	if (DEBUG) {
	print ($query."\n");
}
$result='';
$queried = mysql_query($query) or die('wrong data input [sqa]');
while($row = mysql_fetch_assoc($queried)) {
 $result[]=  $row;
}
$query_counter++;
return($result);
}

// function that executing query and returns array of first result
function simple_query($query) {
global $query_counter;
	if (DEBUG) {
	print ($query."<br />\n");
}
$queried = mysql_query($query) or die('wrong data input [sq]');
$result= mysql_fetch_assoc($queried);
$query_counter++;
return($result);
}



// function that just executing query 
function nr_query($query) {
global $query_counter;
if (DEBUG) {
	print ($query."\n");
}
$queried = mysql_query($query) or die('wrong data input [nrq]');
$query_counter++;
return($queried);
}


$fn_config=rcms_parse_ini_file(CONFIG_PATH.'fastnews.ini');
$news_container=$fn_config['newscontainer'];
$longurl=$fn_config['longurl'];
$modrewrite=$fn_config['modrewrite'];
$printable=$fn_config['printable'];
$viewcounter=$fn_config['viewcounter'];
$enabletagline=$fn_config['enabletagline'];
$showdate=$fn_config['showdate'];
$showviews=$fn_config['showviews'];

//////////////////////////
// API section          //
//////////////////////////
$db =new MySQLDB();


function deb($string) {
    show_window('DEBUG',$string);
}

function fncfr() {
    global $system;
    if($system->checkForRight('FASTNEWS')) {
     return(true);
     }
     else {
     return(false);
     }
}

function translit_string($var) {
    $NpjLettersFrom = " ";
    $NpjLettersTo   = "abvgdeziklmnoprstufcyiie_";
    $NpjBiLetters = array(
        "" => "jj", "" => "jo", "" => "zh", "" => "kh", "" => "ch",
        "" => "sh", "" => "shh", "" => "je", "" => "ju", "" => "ja",
        "" => "", "" => "");

    $NpjCaps  = "Ũ߲ ";
    $NpjSmall = " ";

    $var = trim(strip_tags($var));
    $var = preg_replace( "/s+/ms", "_", $var );
    $var = strtr( $var, $NpjCaps, $NpjSmall );
    $var = strtr( $var, $NpjLettersFrom, $NpjLettersTo );
    $var = strtr( $var, $NpjBiLetters );
    $var = preg_replace("/[^a-z0-9_]+/mi", "", $var);
    $var = strtolower ( $var );
    return ($var);
}

function get_containers() {
    $query='SELECT `id`,`name` from `containers`';
    $allcontainers=simple_queryall($query);
    return ($allcontainers);
}

function get_container_desc($cid) {
    $query='SELECT `desc` from `containers` WHERE `id`="'.$cid.'"';
    $result=simple_query($query);
    return($result['desc']);
}


function get_container_categories($cid) {
    $query='SELECT `id`,`name`,`desc` from `categories` WHERE `cont`="'.$cid.'"';
    $result=simple_queryall($query);
    return($result);
}

function list_containers() {
    $allcont=get_containers();
    $presult='';
    if (!empty ($allcont)) {
    foreach ($allcont as $key=>$val) {
        $contname=$val['name'];
        $result='';
        if (($contname!='#root') AND ($contname!='#hidden')) {
            $result.='<br /><a href="?module=fn&c='.$contname.'">'.__(get_container_desc($val['id'])).'</a><br />';
            $cats=get_container_categories($val['id']);
            if (!empty ($cats)) {
            foreach ($cats as $key=>$eachcat) {
                $result.='&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <a href="?module=fn&c='.$contname.'&b='.$eachcat['id'].'">'.$eachcat['name'].'</a><br />';
            }
            }
            $presult.=$result;

        }
    }
    }
    show_window(__('Sections'),$presult);
}

function fn_article_date ($date) {
    global $showdate;
    if ($showdate) {
        $result=__('Date').' '.$date;
    } else {
        $result='';
    }
    return($result);
}

function fn_article_views ($views) {
    global $showviews;
    if ($showviews) {
        $result=__('Views').' '.$views;
    } else {
        $result='';
    }
    return($result);
}

function get_category_desc($cat_id) {
    $query='SELECT `name` from `categories` WHERE `id`="'.$cat_id.'"';
    $result=simple_query($query);
    return($result['name']);
}
function get_container_sname($container_id) {
 $query='SELECT `name` from `containers` WHERE `id`="'.$container_id.'"';
 $result=simple_query($query);
 return($result['name']);
}

function get_container_id($container_name) {
 $query='SELECT `id` from `containers` WHERE `name`="'.$container_name.'"';
 $result=simple_query($query);
 return($result['id']);
}

function list_categories($container_id) {
$result='';
$query='SELECT `id`,`name`,`desc` from `categories` WHERE `cont`="'.$container_id.'"';
$allcats=simple_queryall($query);
if (!empty ($allcats)) {
foreach ($allcats as $key=>$eachcat) {
    $result.='<a href="?module=fn&c='.get_container_sname($container_id).'&b='.$eachcat['id'].'">'.$eachcat['name'].'</a> <br />';
  }
 }
 show_window(__(get_container_desc($container_id)),$result);
}

function article_template_short($title,$short,$views,$date,$article_id) {
    global $enabletagline;
    $template='<table style="text-align: left; width: 100%;"  cellpadding="2" cellspacing="2" class="grayborder">
    <tbody>
    <tr>
      <td class="winheader">
    <b>'.$title.'</b>
      </td>
    </tr>
    <tr>
      <td>
      '.$short.'
      </td>
    </tr>
    <tr>
      <td>
     '.fn_article_date($date).' '.fn_article_views($views).' '.fn_show_printable($article_id).'  '.fn_show_article_control($article_id).'
     </td>
    </tr>
  </tbody>
</table>
<br>
';
    if ($enabletagline) {
     $template.=fn_get_tagline($article_id);
    }

    return($template);
}

function fn_show_article_control($article_id) {
    $result='';
    if (fncfr()) {
    $result='&nbsp;&nbsp;&nbsp;
   <a href="?module=fnadmin&action=movedraft&artid='.$article_id.'"><img src="skins/fastnews/trash_small.gif" title="'.__('Drafts').'" border="0"></a>&nbsp;&nbsp;&nbsp;
   <a href="?module=fnadmin&action=articleedit&artid='.$article_id.'"><img src="skins/fastnews/edit_small.gif" title="'.__('Edit').'" border="0"></a>&nbsp;&nbsp;&nbsp;
   <a href="?module=fnadmin&action=tagarticle&artid='.$article_id.'"><img src="skins/fastnews/tag_small.gif" title="'.__('Tags').'" border="0"></a>
    ';
    }
    return($result);
}

function article_comment_template($id,$login,$nickname,$ip,$date,$text) {
$login=trim($login);
    if (fncfr()) {
     $buttons='
     '
     .$ip.
     '

    <form action="" method="POST">
      <input type="hidden" name="cdelete" value="'.$id.'" />
      <input type="submit" name="" class="delete_button" value="" />
     </form>

      ';
    } else {
     $buttons='';
    }
    $template='
     <table style="text-align: left; width: 100%;" border="0" cellpadding="2" cellspacing="2">
  <tbody>
    <tr>
      <td><b><a href="?module=user.list&user='.trim($login).'">'.$nickname.'</a></b></td>
      <td>'.$date.'</td><td align="right">'.$buttons.'</td>
    </tr>
    <tr>
      <td width="10%">'.show_avatar($login).'</td>
      <td valign="top" width="80%">'.$text.'</td>
      <td></td>
    </tr>
  </tbody>
</table>

    ';

  return($template);
 }

function article_template_full($full,$views,$date,$article_id) {
    global $enabletagline;
    $template='<table style="text-align: left; width: 100%;"  cellpadding="2" cellspacing="2" class="grayborder">
    <tbody>
    <tr>
      <td>
      '.$full.'
      </td>
    </tr>
    <tr>
      <td>
     '.fn_article_date($date).' '.fn_article_views($views).' '.fn_show_article_control($article_id).'
     </td>
    </tr>
  </tbody>
</table>
<br>
';

    if ($enabletagline) {
     $template.=fn_get_tagline($article_id);
    }
    return($template);
}

function fn_get_article_count_category($category_id) {
$query='SELECT COUNT(`id`) FROM `articles` WHERE `category`="'.$category_id.'"';
$result=simple_query($query);
return($result['COUNT(`id`)']);
}

function list_articles_cat($container,$category_id,$from=1) {
    global $longurl;
    global $system;
    global $modrewrite;
    $result='';
    $cname='';
    $perpage=$system->config['perpage'];
    $container=$container;
    $cur=$from-1;
    $tcount=fn_get_article_count_category($category_id);
    $query='SELECT * from `articles` WHERE `category`="'.$category_id.'" ORDER BY `date` DESC LIMIT '.($cur)*$perpage.','.$perpage.'';
    $allarticles=simple_queryall($query);
    if (!empty ($allarticles)) {
     //
     //paginator - hate this
     //
    $link='?module=fn&c='.$container.'&b='.$category_id.'';
    $result.=rcms_pagination($tcount,$perpage, $from, $link).'<br />';
    ////////////////////////
    foreach ($allarticles as $key=>$article) {
        if ($longurl) {
            $lu=translit_string($article['title']);
            $hurl='&h='.$lu;
        } else {
            $hurl='';
        }
        // , ?
        if (!$modrewrite) {
        $title='<a href="?module=fn&a='.$article['id'].$hurl.'">'.$article['title'].'</a><br />';
        } else {
         $title='<a href="fn/a/'.$article['id'].'/'.$lu.'">'.$article['title'].'</a><br />';
        }
        //   
        if ($article['mode']=='html') {
            $short=$article['short'];
        } else {
            $short=rcms_parse_text($article['short'], true, false, true, true, true, false);
        }
        $result.=article_template_short($title,$short,$article['views'],$article['date'],$article['id']);
        $cname=get_category_desc($article['category']);
     }

    $result.=rcms_pagination($tcount,$perpage, $from, $link);
    }
    show_window($cname,$result);
  }

function plus_article_view($article_id) {
$query='SELECT `views` from `articles` where `id`="'.$article_id.'"';
$current_views=simple_query($query);
$new_views=$current_views['views']+1;
$update="UPDATE `articles` SET `views` = '".$new_views."' WHERE `id` ='".$article_id."' LIMIT 1 ;";
nr_query($update);
}

function fn_show_comments($article_id) {
   $query='SELECT * from `comments` WHERE `artid`="'.$article_id.'" ORDER BY `date` DESC';
   $result='<a name="comments"></a>';
   $allcomments=simple_queryall($query);
   if (!empty($allcomments)) {
   foreach ($allcomments as $key=>$eachcomment) {
   $id=$eachcomment['id'];
   $login=rcms_parse_text($eachcomment['login']);
   $nickname=rcms_parse_text($eachcomment['nickname']);
   $ip=$eachcomment['ip'];
   $date=$eachcomment['date'];
   $text=rcms_parse_text($eachcomment['text']);
   $result.=article_comment_template($id,$login, $nickname, $ip, $date, $text);
   }

   show_window(__('Comments'),$result);
   }

}

function fn_delete_comment($cid) {
    $query='DELETE FROM `comments` WHERE `id`="'.$cid.'" LIMIT 1';
    nr_query($query);
}

function fn_comment_form($comments) {
   if(trim($comments) == 'yes') {
      if (LOGGED_IN) {
		show_window(__('Post comment'), rcms_parse_module_template('comment-post.tpl', array('text'=>'')), 'center');
	      } else {
	        show_window(__('Post comment'), __('You are not logined!'), 'center');
		}
	}
}
function show_article_full($article_id) {
    global $viewcounter;
    global $system;
    $query='SELECT * from `articles` WHERE `id`="'.$article_id.'"';
    $fullarticle=simple_query($query);
    $title=$fullarticle['title'];
    //         :)
    $system->config['pagename'] = $fullarticle['title'];
    $views=$fullarticle['views'];
    $date=$fullarticle['date'];
    $comments=$fullarticle['comments'];
    if ($fullarticle['mode']=='html') {
        $full=$fullarticle['full'];
    } else {
        $full=rcms_parse_text($fullarticle['full']);
        $full=rcms_parse_text($fullarticle['full'], true, false, true, false, true, false);
    }
    $result=article_template_full($full, $views, $date,$fullarticle['id']);
    if ($viewcounter==true) {
        plus_article_view($article_id);
    }
    show_window($title,$result);
    fn_comment_form($comments);
    fn_show_comments($article_id);
}

function is_commentable($article_id) {
    $query='SELECT `comments` from `articles` WHERE `id`="'.$article_id.'"';
    $cmntbl=simple_query($query);
    if ($cmntbl['comments']=='yes') {
        return (true);
    } else {
        return (false);
    }
}

function nf_add_comment($article_id,$text) {
    global $system;
    if ((!empty($text)) AND (is_commentable($article_id))) {
      $login=$system->user['username'];
      $nickname=$system->user['nickname'];
      $time = gmdate("Y-m-d H:i:s",rcms_get_time());
      $ip=$_SERVER['REMOTE_ADDR'];
      $comtext=mysql_real_escape_string($text);
      $query="
      INSERT INTO `comments` (
        `id` ,
        `artid` ,
        `login` ,
        `nickname` ,
        `ip` ,
        `date` ,
        `text`
        )
        VALUES (
        NULL , '".$article_id."', '".$login."', '".$nickname."', '".$ip."', '".$time."', '".$comtext."'
        );
      ";
       if (LOGGED_IN) {
       nr_query($query);
        }
    }
}
function fn_show_admin_panel() {
    if (fncfr()){
    $result='
    <a href="?module=fnadmin&action=new"><img src="skins/fastnews/article.gif" border="0" title="'.__('Post article').'"></a>&nbsp;
    <a href="?module=fnadmin&action=contedit"><img src="skins/fastnews/container.gif" border="0" title="'.__('Manage containers').'"></a>&nbsp;
    <a href="?module=fnadmin&action=catedit"><img src="skins/fastnews/category.gif" border="0" title="'.__('Manage categories').'"></a>&nbsp;
    <a href="?module=fnadmin&action=backups"><img src="skins/fastnews/backup.gif" border="0" title="'.__('Backups management').'"></a>&nbsp;
    <a href="?module=fnadmin&action=pages&newpage=true"><img src="skins/fastnews/page.gif" border="0" title="'.__('Static pages').'"></a>&nbsp;
    <a href="?module=fnadmin&action=gallery"><img src="skins/fastnews/gallery.gif" border="0" title="'.__('Gallery').'"></a>&nbsp;
    <a href="?module=fnadmin&action=drafts"><img src="skins/fastnews/trash.gif" border="0" title="'.__('Drafts').'"></a>&nbsp;
    <a href="?module=fnadmin&action=console"><img src="skins/fastnews/console.gif" border="0" title="'.__('Console').'"></a>&nbsp;
    <a href="?module=fnadmin&action=configure"><img src="skins/fastnews/config.gif" border="0" title="'.__('Settings').'"></a>&nbsp;
    ';
    $apanel_addons_path=CONFIG_PATH.'fnaddons/';
    $all_addons=rcms_scandir($apanel_addons_path);
    if (!empty ($all_addons)) {
      foreach ($all_addons as $eachaddon) {
          $result.=file_get_contents($apanel_addons_path.$eachaddon);
      }
    }
    show_window('',$result);
    }
}

function fn_category_selector($current='') {
$query='SELECT * from `categories`';
$result='<select name="category">';
$allcats=simple_queryall($query);
if (!empty ($allcats)) {
   foreach ($allcats as $key=>$eachcat) {
     $flag='';
     if ($current) {
         if ($current==$eachcat['id']) {
             $flag='SELECTED';
         }
     } 
     $result.='<OPTION VALUE="'.$eachcat['id'].'" '.$flag.'>'.$eachcat['name'].'</option>'."\n";
   }
 }
 $result.='</select>';
 return ($result);
}

function fn_container_selector() {
$query='SELECT * from `containers`';
$result='<select name="container">';
$allconts=simple_queryall($query);
if (!empty ($allconts)) {
   foreach ($allconts as $key=>$eachcont) {
     $result.='<OPTION VALUE="'.$eachcont['id'].'">'.__($eachcont['desc']).'</option>'."\n";
   }
 }
 $result.='</select>';
 return ($result);
}

function mode_selector($current='') {
    $flag='';
    $modes=array('text','html');
   
    $result='<select name="mode">';
     foreach ($modes as $eachmode) {
     $flag='';
       if ($current) {
         if ($current==$eachmode) {
             $flag='SELECTED';
         }
     }
    $result.='<option value="'.$eachmode.'" '.$flag.' >'.__($eachmode).'</option>';
     }
    $result.='</select>';
    return($result);
}

function comments_selector($current='') {
    $flag1='';
    $flag2='';
    if ($current) {
         if ($current=='yes') {
             $flag1='SELECTED';
         }
         
         if ($current=='no') {
             $flag2='SELECTED';
         }
     }
    $result='<select name="comments">
    <option value="yes" '.$flag1.'>'.__('Allow').'</option>
    <option value="no" '.$flag2.'>'.__('Disallow').'</option>
    </select>
    ';
    return($result);
}

function fn_show_article_post_form() {
    $result='
<form actio="" method="POST" name="newarticle">
<input type="hidden" name="posting" value="true">
<table style="text-align: left; width: 100%;" border="0" cellpadding="2" cellspacing="2">
  <tbody>
    <tr>
      <td>
      '.fn_category_selector().' '.__('Select category').'
      </td>
    </tr>
    <tr>
      <td>
      <input type="text" name="title" size="60"> '.__('Title').'
      </td>
    </tr>
    <tr>
       <td>
       <input type="text" name="source" size="60"> '.__('Author/source').'
      </td>
    </tr>
    <tr>
      <td>
      '.__('Short description').'
      <br />
      '.rcms_show_bbcode_panel('newarticle.short').'
      <textarea name="short" cols="60" rows="10"></textarea>
      </td>
    </tr>
    <tr>
       <td>
      '.__('Text').'
      <br />
     '.rcms_show_bbcode_panel('newarticle.full').'
      <textarea name="full" cols="60" rows="25"></textarea>
      </td>
    </tr>
    <tr>
      <td>'.__('Date').'
      <input type="text" name="date" value="'.$time = gmdate("Y-m-d H:i:s",rcms_get_time()).'"
      </td>
    </tr>
    <tr>
      <td>'.__('Mode').'
      '.mode_selector().'
      </td>
    </tr>
    <tr>
      <td>'.__('Allow comments').'
     '.comments_selector().'
      </td>
    </tr>
  </tbody>
</table>
<p align="center">
<input type="submit">
</p>
</form>
     ';
    return($result);
}


function fn_add_new_article($category,$title,$source,$short,$full,$date,$mode,$comments) {
    $category=mysql_real_escape_string($category);
    $title=mysql_real_escape_string($title);
    $source=mysql_real_escape_string($source);
    //$short=mysql_real_escape_string($short);
    //$full=mysql_real_escape_string($full);
    $date=mysql_real_escape_string($date);
    $query="
     INSERT INTO `articles` (
     `id` ,
     `category` ,
     `title` ,
     `source` ,
     `keywords` ,
     `short` ,
     `full` ,
     `mode` ,
     `views` ,
     `date` ,
     `comments`
                                     )
     VALUES (
     NULL , '".$category."', '".$title."', '".$source."', NULL , '".$short."', '".$full."', '".$mode."', '0', '".$date."', '".$comments."'
     );
";
    nr_query($query);
    show_window(__('Result'),__('Article saved'));
}

function fn_container_delete_form() {
    $result='
    <form action="" method="POST" >
    <input type="hidden" name="delcont" value="true">
    '.__('Select container').': '.fn_container_selector().'
    <input type="submit" value="'.__('Delete').'">
    </form>
    ';
    return ($result);
}
function fn_container_edit_form() {
    $result='
    <form action="" method="POST" >
    <input type="hidden" name="editcont" value="true">
    '.__('Select container').': '.fn_container_selector().'<br/>'
    .__('Title').': <input type="text" name="newname" >
    <input type="submit" value="'.__('Update').'">
    </form>
    ';
    return ($result);
}

function fn_category_delete_form() {
    $result='
    <form action="" method="POST" >
    <input type="hidden" name="delcat" value="true">
    '.__('Select category').' '.fn_category_selector().'
    <input type="submit" value="'.__('Delete').'">
    </form>
    ';
    return ($result);
}
function fn_category_edit_form() {
    $result='
    <form action="" method="POST" >
    <input type="hidden" name="editcat" value="true">
    '.__('Select category').': '.fn_category_selector().'<br/>'
    .__('Title').': <input type="text" name="newname" >
    <input type="submit" value="'.__('Update').'">
    </form>
    ';
    return ($result);
}

function fn_container_add_form() {
    $result='
    <form action="" method="POST" >
    <input type="hidden" name="addcont" value="true">
     <input type="text" name="name"> '.__('ID').'<br>
     <input type="text" name="desc"> '.__('Description').'<br>
    <input type="submit" value="'.__('Add').'">
    </form>
    ';
    return ($result);
}

function fn_category_add_form() {
    $result='
    <form action="" method="POST" >
    <input type="hidden" name="addcat" value="true">
     '.fn_container_selector().' '.__('Select container').'<br>
     <input type="text" name="name"> '.__('Create new category').'<br>
    <input type="submit" value="'.__('Add').'">
    </form>
    ';
    return ($result);
}


function fn_delete_container($container_id) {
    $query='DELETE FROM `containers` WHERE `id`="'.$container_id.'"';
    nr_query($query);
    show_window(__('Container'),__('Container deleted'));
}

function fn_update_container($container_id,$newname) {
	$update="UPDATE `containers` SET `desc` = '".$newname."' WHERE `id` ='".$container_id."'";
	nr_query($update);
    show_window(__('Container'),__('Container updated'));
}

function fn_delete_category($category_id) {
    $query='DELETE FROM `categories` WHERE `id`="'.$category_id.'"';
    nr_query($query);
    show_window(__('Manage categories'),__('Category removed'));
}


function fn_add_container($name,$desc) {
$query="
INSERT INTO `containers` (
           `id` ,
           `name` ,
           `desc`
               )
        VALUES (
    NULL , '".$name."', '".$desc."'
              );";
    nr_query($query);
    show_window(__('Container'),__('Container created'));
}

function fn_add_category($container,$name) {
    $query="
  INSERT INTO `categories` (
            `id` ,
            `cont` ,
            `name` ,
            `desc` ,
            `icon` ,
            `acess`
            )
     VALUES (
     NULL , '".$container."', '".$name."', NULL , NULL , NULL);
";
    nr_query($query);
    show_window(__('Category created'), __('Category created'));
}
function fn_update_category($category_id,$newname) {
	$update="UPDATE `categories` SET `name` = '".$newname."' WHERE `id` ='".$category_id."'";
	nr_query($update);
    show_window(__('Category'),__('Category updated'));
}


function fn_backup_database(){
 show_window(__('Backup data'),__('Backup complete'));
 backup_tables();
 }

function fn_show_sql_console() {
$form='
<form action="" method="POST">
<textarea name="sqlq" cols="80" rows="10">
</textarea>
<br>
<input type="submit">
</form>
';
show_window('SQL console',$form);
if (isset($_POST['sqlq'])) {
$vdump=var_export(simple_queryall($_POST['sqlq']),true);
show_window(__('SQL Console'),'<pre>'.$vdump.'</pre>');
 }
}
function get_all_categories() {
    $query='SELECT `id`,`cont` from `categories`';
    $allcats=simple_queryall($query);
    return($allcats);
}

function count_articles_by_category($category_id) {
    $query='SELECT COUNT(`id`) from `articles` where `category`="'.$category_id.'"';
    $result=simple_query($query);
    return($result['COUNT(`id`)']);
}

function fn_show_tagedit_form($article_id) {
    $result='<table width="100%" border="0">';
    $current_tags=fn_get_tags($article_id);
    if (!empty ($current_tags)) {
    foreach ($current_tags as $key=>$eachtag) {
       $result.='<tr class="row2"><td><a href="?module=fnadmin&action=tagarticle&deltag='.$eachtag['id'].'&artid='.$article_id.'"><img src="skins/fastnews/trash_small.gif" title="'.__('Delete').'"  border="0"></a> '.$eachtag['tags'].'</td></tr>';
       }
    }
    $result.='</table>';
    $addform='
    <form method="POST" action="?module=fnadmin&action=tagarticle&artid='.$article_id.'">
    <input type="hidden" name="article_id" value="'.$article_id.'">
     <img src="skins/fastnews/tag_small.gif" title="'.__('Add').'"> <input type="text" name="newtag" size="30"> <input type="submit" value="'.__('Add').'">
    </form>
    ';
    $result.=$addform;
    show_window(__('Tags'), $result);
}

function fn_add_tag($article_id,$tag) {
$article_id=vf($article_id,3);
$tag=mysql_real_escape_string($tag);
$query="INSERT INTO `tags`
        ( `id` , `artid` , `tags` )
         VALUES (
        '', '".$article_id."', '".$tag."'
          );";
    nr_query($query);
}

function fn_get_tags($article_id) {
$article_id=vf($article_id,3);
$query='SELECT * from `tags` WHERE `artid`="'.$article_id.'"';
$result=simple_queryall($query);
return ($result);
}

function fn_delete_tag($id) {
$id=mysql_real_escape_string($id);
$query='DELETE from `tags` WHERE `id` ="'.$id.'"';
    nr_query($query);
}

function fn_get_tagline($article_id) {
    $article_id=vf($article_id,3);
    $tagline='';
    $alltags=fn_get_tags($article_id);
    if (!empty ($alltags)) {
        $tagscount=sizeof($alltags);
        $i=0;
        $tagline.='<img src="skins/fastnews/tag_green.gif"> ';
        foreach ($alltags as $key=>$eachtag) {
            $i++;
            $tagline.='<a href="?module=fntags&tag='.$eachtag['tags'].'">'.$eachtag['tags'].'</a>';
             if ($i<$tagscount) {
               $tagline.=', ';
             }
        }
    }
    $tagline.='<br /><br />';
    return ($tagline);
}

function fn_get_articles_by_tag($tag) {
    $tag=mysql_real_escape_string($tag);
    $query='SELECT `artid` from `tags` WHERE `tags`="'.$tag.'"';
    $target_articles=simple_queryall($query);
    return($target_articles);
}

function fn_get_article_title($article_id) {
    $article_id=vf($article_id,3);
    $query='SELECT `title` from `articles` WHERE `id` = "'.$article_id.'"';
    $result=simple_query($query);
    return($result['title']);
}



function fn_show_articles_by_tag($tag) {
    $allarticles=fn_get_articles_by_tag($tag);
    $result='';
     if (!empty ($allarticles)) {
        foreach ($allarticles as $key=>$article) {
         $result.='<a href="?module=fn&a='.$article['artid'].'">'.fn_get_article_title($article['artid']).'</a> <br />';
        }
       }
   show_window(__('Articles'), $result);
}

function fn_get_article_data($article_id) {
    $article_id=vf($article_id,3);
    $query='SELECT * from `articles` WHERE `id` = "'.$article_id.'"';
    $result=simple_query($query);
    return($result);
}
function fn_show_article_edit_form($article_id) {
    $body=fn_get_article_data($article_id);
    $result=fn_show_article_control($article_id);
       $result.='
<form actio="" method="POST" name="newarticle">
<input type="hidden" name="updatearticle" value="'.$article_id.'">
<table style="text-align: left; width: 100%;" border="0" cellpadding="2" cellspacing="2">
  <tbody>
    <tr>
      <td>
      '.fn_category_selector($body['category']).' '.__('Select category').'
      </td>
    </tr>
    <tr>
      <td>
      <input type="text" name="title" size="60" value="'.$body['title'].'"> '.__('Title').'
      </td>
    </tr>
    <tr>
       <td>
       <input type="text" name="source" size="60" value="'.$body['source'].'"> '.__('Author/source').'
      </td>
    </tr>
    <tr>
      <td>
      '.__('Short description').'
      <br />
      '.rcms_show_bbcode_panel('newarticle.short').'
      <textarea name="short" cols="60" rows="10">'.$body['short'].'</textarea>
      </td>
    </tr>
    <tr>
       <td>
      '.__('Text').'
      <br />
     '.rcms_show_bbcode_panel('newarticle.full').'
      <textarea name="full" cols="60" rows="25">'.$body['full'].'</textarea>
      </td>
    </tr>
    <tr>
      <td>'.__('Date').'
      <input type="text" name="date" value="'.$body['date'].'"
      </td>
    </tr>
    <tr>
      <td>'.__('Mode').'
      '.mode_selector($body['mode']).'
      </td>
    </tr>
    <tr>
      <td>'.__('Allow comments').'
     '.comments_selector($body['comments']).'
      </td>
    </tr>
  </tbody>
</table>
<p align="center">
<input type="submit">
</p>
</form>
     ';
    return($result);
}

function fn_update_article($article_id,$category,$title,$source,$short,$full,$mode,$date,$comments) {
    
    $query='UPDATE `articles` SET 
    `category` = "'.$category.'",
    `title` = "'.$title.'",
    `source` = "'.$source.'",
    `short` = "'.$short.'",
    `full` = "'.$full.'",
    `mode` = "'.$mode.'",
    `date` = "'.$date.'",
    `comments` = "'.$comments.'"
     WHERE `id` = "'.$article_id.'";
     ';
    nr_query($query);
}

function fn_add_new_draft($category,$title,$source,$short,$full,$date,$mode,$comments) {
    $category=mysql_real_escape_string($category);
    $title=mysql_real_escape_string($title);
    $source=mysql_real_escape_string($source);
    $short=mysql_real_escape_string($short);
    $full=mysql_real_escape_string($full);
    $date=mysql_real_escape_string($date);
    $query="
     INSERT INTO `drafts` (
     `id` ,
     `category` ,
     `title` ,
     `source` ,
     `keywords` ,
     `short` ,
     `full` ,
     `mode` ,
     `views` ,
     `date` ,
     `comments`
                                     )
     VALUES (
     NULL , '".$category."', '".$title."', '".$source."', NULL , '".$short."', '".$full."', '".$mode."', '0', '".$date."', '".$comments."'
     );
";
    nr_query($query);
    show_window(__('Result'),__('Article saved'));
}

function fn_delete_article($article_id) {
$query='DELETE from `articles` WHERE `id`="'.$article_id.'"';
nr_query($query);
}

function fn_delete_draft($article_id) {
$query='DELETE from `drafts` WHERE `id`="'.$article_id.'"';
nr_query($query);
}

function fn_exists_article($article_id) {
    $query='SELECT `title` from `articles` WHERE `id`="'.$article_id.'"';
    $title=simple_query($query);
    if (!empty ($title)) {
        return (true);
    } else {
        return (false);
    }
}


function fn_show_drafts() {
   $query='SELECT * from `drafts` ORDER BY `date` DESC';
   $result='<table width="100%" border="0"  cellpadding="2" cellspacing="2">';
   $alldrafts=simple_queryall($query);
   if (!empty ($alldrafts)) {
       foreach ($alldrafts as $key=>$eachdraft) {
         $id=$eachdraft['id'];
         $result.='<tr row="2">
         <td><a href="?module=fnadmin&action=drafts&deldraft='.$id.'"><img src="skins/fastnews/delete.gif" border="0" title="'.__('Delete').'"></a></td>
         <td><a href="#" title="'.strip_tags($eachdraft['short']).'">'.$eachdraft['title'].'</a></td>
         <td>'.$eachdraft['date'].'</td>
         <td><a href="?module=fnadmin&action=drafts&publishdraft='.$id.'"><img src="skins/fastnews/edit_small.gif" border="0" title="'.__('Publish to site').'"></a></td>
         </tr>';
       }
   }
   $result.='</table>';
   show_window(__('Drafts'),$result);
}

function fn_get_draft_data($draft_id) {
    $draft_id=vf($draft_id,3);
    $query='SELECT * from `drafts` WHERE `id` = "'.$draft_id.'"';
    $result=simple_query($query);
    return($result);
}

function fn_publish_draft($draft_id) {
    $draft=fn_get_draft_data($draft_id);
    fn_add_new_article($draft['category'], $draft['title'], $draft['source'], $draft['short'], $draft['full'], $draft['date'], $draft['mode'], $draft['comments']);
    fn_delete_draft($draft_id);
}

function fn_show_printable($article_id) {
    global $printable;
    $result='';
    if ($printable) {
     $result.='<a href="?module=fnprnt&artid='.$article_id.'"><img src="skins/fastnews/printer_small.gif" border="0" title="'.__('Printable version').'"></a> ';
    }
    return($result);
}


function article_template_print($full,$mode) {
    global $system;
   $copy=$system->config['copyright'];
   if ($mode=='html') {
     $full=$full;
    } else {
     $full=rcms_parse_text($full, true, false, true, true, true, false);
    }
    $template='<table style="text-align: left; width: 100%;"  cellpadding="2" cellspacing="2" class="grayborder">
    <tbody>
    <tr>
      <td>
      '.$full.'
      </td>
    </tr>
    <tr>
      <td>
      &copy; '.$copy.'
      </td>
    </tr>
    </tbody>
</table>
<br>
';

   return($template);
}


function fn_add_static_page($name,$text) {
    $name=vf($name,1);
    $text=mysql_real_escape_string($text);
    $query="INSERT INTO `pages` (
`id` ,
`name` ,
`text`
)
VALUES (
NULL , '".$name."', '".$text."'
);";
    nr_query($query);
    $pagelink=__('Page link').': <input type="text" value="?module=fnpages&pid='.$name.'" size="30">';
    show_window(__('Page added'),$pagelink);
}

function fn_show_page_add_form() {
    $form='
   <form method="POST" action="?module=fnadmin&action=pages">
   <input type="text" name="newpagename" size="40"> '.__('Page name').' (URL)<br>
    '.__('Text').'<br>
   <textarea name="newpagetext" cols="60" rows="30"></textarea><br>
   <input type="submit" value="'.__('Add').'">
   </form>
    ';
    show_window(__('Page add'),$form);
}

function fn_list_static_pages() {
$query='SELECT * from `pages`';
$allpages=simple_queryall($query);
$result='';
if (!empty ($allpages)) {
    foreach ($allpages as $key=>$eachpage) {
        $result.='<a href="?module=fnadmin&action=pages&delpage='.$eachpage['id'].'">
        <img src="skins/fastnews/delete.gif" border="0" title="'.__('Delete').'"></a>
         <input type="text" value="?module=fnpages&pid='.$eachpage['name'].'" size="30"> 
         <a href="?module=fnpages&pid='.$eachpage['name'].'" title="'.__('Preview').'">'.$eachpage['name'].'
        <a href="?module=fnadmin&action=pages&updatepage='.$eachpage['id'].'">
        <img src="skins/fastnews/edit_small.gif" border="0" title="'.__('Edit').'"></a> <br /> ';
    }
 }
 show_window(__('Pages'),$result);
}

function fn_delete_page($pageid) {
    $query='DELETE FROM `pages` WHERE `id` = "'.$pageid.'"';
    nr_query($query);
    show_window(__('Result'),__('Deleted'));
}

function fn_get_page_data($page_id) {
    $query='SELECT * from `pages` WHERE `id`="'.$page_id.'"';
    $pagedata=simple_query($query);
    return ($pagedata);
}

function fn_show_page_update_form($page_id) {
    $pagedata=fn_get_page_data($page_id);
    $form='
   <form method="POST" action="?module=fnadmin&action=pages&updatepage='.$page_id.'">
   <input type="hidden" name="updatepageid" value="'.$pagedata['id'].'">
   <input type="text" name="updatepagename" size="40" value="'.$pagedata['name'].'"> '.__('Page name').' (URL)<br>
    '.__('Text').'<br>
   <textarea name="updatepagetext" cols="60" rows="30">'.$pagedata['text'].'</textarea><br>
   <input type="submit" value="'.__('Add').'">
   </form>
    ';
    show_window(__('Page edit'),$form);
}

function fn_update_page($page_id,$name,$text) {
    $name=vf($name,1);
    $text=mysql_real_escape_string($text);
    $query="UPDATE `pages` SET `name` = '".$name."',
     `text` = '".$text."' WHERE `id` =".$page_id." LIMIT 1;";
    nr_query($query);
}

function fn_param_selector($name,$current=0) {
    $selector='<select name="'.$name.'">';
    if ($current==0) {
    $selector.='<option value="0" SELECTED>'.__('Disable').'</option><option value="1">'.__('Enable').'</option>';
    } else {
    $selector.='<option value="0">'.__('Disable').'</option><option value="1" SELECTED>'.__('Enable').'</option>';
    }
    $selector.='</select>';
    return ($selector);
}

function fn_show_setings_form() {
global $news_container;
global $longurl;
global $modrewrite;
global $printable;
global $viewcounter;
global $enabletagline;
global $showdate;
global $showviews;
    $form='
    <form method="POST" action="?module=fnadmin&action=configure">
    <input type="hidden" name="settingschange" value="true">
    <input type="text" name="newscontainer" value="'.$news_container.'"> '.__('News container ID').'<br />
    '.fn_param_selector('longurl',$longurl).' '.__('Long URL').'<br />
    '.fn_param_selector('modrewrite',$modrewrite).' '.__('Modrewrite support').'<br />
    '.fn_param_selector('printable',$printable).' '.__('Printable version').'<br />
    '.fn_param_selector('viewcounter',$viewcounter).' '.__('Article view counter').'<br />
    '.fn_param_selector('enabletagline',$enabletagline).' '.__('Tagline display').'<br />
    '.fn_param_selector('showdate',$showdate).' '.__('Article date display').'<br />
    '.fn_param_selector('showviews',$showviews).' '.__('Article views display').'<br />
    <input type="submit" value="'.__('OK').'">
    </form>
    ';

 show_window(__('Settings'),$form);
}

function fn_save_settings() {
    if (isset($_POST['settingschange'])) {
        if (!empty ($_POST['newscontainer'])) {
       $newconfig='newscontainer='.trim($_POST['newscontainer']).'
longurl='.$_POST['longurl'].'
modrewrite='.$_POST['modrewrite'].'
printable='.$_POST['printable'].'
viewcounter='.$_POST['viewcounter'].'
enabletagline='.$_POST['enabletagline'].'
showdate='.$_POST['showdate'].'
showviews='.$_POST['showviews'].'
        ';
        }
     file_write_contents(CONFIG_PATH.'fastnews.ini', $newconfig);
     show_window(__('Result'),__('Settings saved'));
     rcms_redirect('?module=fnadmin&action=configure');
    }
}

function fn_show_static_page ($page_name) {
    $page_name=vf($page_name,1);
    $query='SELECT `id` FROM `pages` WHERE `name`="'.$page_name.'"';
    $pageid=simple_query($query);
    if (!empty ($pageid)) {
        $pagedata=fn_get_page_data($pageid['id']);
        show_window('', $pagedata['text']);
    }
}






/* backup the db OR just a table */
function backup_tables($tables = '*')
{

	if($tables == '*')
	{
		$tables = array();
		$result = mysql_query('SHOW TABLES');
		while($row = mysql_fetch_row($result))
		{
			$tables[] = $row[0];
		}
	}
	else
	{
		$tables = is_array($tables) ? $tables : explode(',',$tables);
	}
        $return='';

	//cycle through
	foreach($tables as $table)
	{
		$result = mysql_query('SELECT * FROM '.$table);
		$num_fields = mysql_num_fields($result);
		//$return.= 'DROP TABLE '.$table.';';
		$row2 = mysql_fetch_row(mysql_query('SHOW CREATE TABLE '.$table));
		$return.= "\n\n".$row2[1].";\n\n";

		for ($i = 0; $i < $num_fields; $i++)
		{
			while($row = mysql_fetch_row($result))
			{
				$return.= 'INSERT INTO '.$table.' VALUES(';
				for($j=0; $j<$num_fields; $j++)
				{
					$row[$j] = addslashes($row[$j]);
					$row[$j] = ereg_replace("\n","\\n",$row[$j]);
					if (isset($row[$j])) { $return.= '"'.$row[$j].'"' ; } else { $return.= '""'; }
					if ($j<($num_fields-1)) { $return.= ','; }
				}
				$return.= ");\n";
			}
		}
		$return.="\n\n\n";
	}

	//save file
        $backname='backups/sql/fastnews-db-backup-'.time().'.sql';
	$handle = fopen($backname,'w+');
	fwrite($handle,$return);
	fclose($handle);
        show_window(__('Result'),$backname);
}


function fn_show_backup_control() {
    $form='<form action="?module=fnadmin&action=backups" method="POST">
    <input type="hidden" name="createbackup" value="true"> <input type="submit" value="'.__('Create database dump').'">
    </form>';
    show_window(__('Backups'),$form);
}

// FNgallery functions
function fn_get_gallery_count() {
    $query='SELECT COUNT(`id`) FROM `gallery`';
    $result=simple_query($query);
    return($result['COUNT(`id`)']);
}

function fn_show_gallery($from) {
    global $system;
    $cur=$from-1;
    $perpage=$system->config['perpage'];
    $query='SELECT * FROM `gallery` ORDER BY `id` DESC LIMIT '.($cur*$perpage).', '.$perpage;
    $result='  <script src="modules/jsc/PopBox.js" type="text/javascript"></script>  <script type="text/javascript">   popBoxShowRevertBar = false;   popBoxShowRevertText = false;   popBoxShowRevertImage = false;  </script>';
    $link='?module=fngallery';
    $totcount=fn_get_gallery_count();
    $allgallery=simple_queryall($query);
    if (!empty ($allgallery)) {
       foreach ($allgallery as $key=>$eachpicture) {
           $result.=' <a href="#">
             <img id="'.rand(0,666).'" src="content/fngallery/'.$eachpicture['filename'].'" border="0"  pbshowcaption="true" style="width: 150px; visibility: visible;" class="PopBoxImageSmall" onclick="Pop(this,50,\'PopBoxImageLarge\');">
             </a> ';
            if (fncfr()) {
            $result.='<a href="?module=fnadmin&action=gallery&deletepic='.$eachpicture['id'].'"><img src="skins/fastnews/delete.gif" border="0" title="'.__('Delete').'"></a>';
         }
        }

    $result.='<br />'.rcms_pagination($totcount,$perpage, $from, $link).'<br />';
    }
    show_window(__('Gallery'),$result);
}

function fn_get_picture_data($picid) {
    $query='SELECT * from `gallery` WHERE `id` = "'.$picid.'"';
    $result=simple_query($query);
    return($result);
}

function fn_gallery_deletepic($picid) {
    $picdata=fn_get_picture_data($picid);
    $filename=$picdata['filename'];
    $query='DELETE from `gallery` WHERE `id`= "'.$picid.'"';
    nr_query($query);
    unlink(DATA_PATH.'fngallery/'.$filename);
    show_window(__('Result'),__('Image removed'));
}

function fn_upload_pic() {
global $system;
$siteurl=$system->url;
if ((isset($_POST['upload_pic'])) AND ($_POST['upload_pic']=="true")) {
$newfilename=basename($_FILES['picload']['name']);
$query="
INSERT INTO `gallery` (
`id` ,
`filename` ,
`title`
)
VALUES (
NULL , '".$newfilename."', 'NULL'
);
";
nr_query($query);
$uploadfile = DATA_PATH.'fngallery/' . $newfilename;
$insertlink='
<input type="text" size="50" value="<img src='.$siteurl.DATA_PATH.'fngallery/'.$newfilename.'>"> '.__('HTML').' <br />
<input type="text" size="50" value="[img]'.$siteurl.DATA_PATH.'fngallery/'.$newfilename.'[/img]"> '.__('Text').' <br />
';
show_window(__('Images uploaded'),$insertlink);
if ((move_uploaded_file($_FILES['picload']['tmp_name'], $uploadfile))) {
     return $_FILES['picload']['name'];
  }
 }
}

function fn_pic_upload_form()
{
global $picture_size;
$form='<form enctype="multipart/form-data" action="?module=fnadmin&action=gallery" method="POST">
       <input type="hidden" name="upload_pic" value="true">
       <input type="hidden" name="MAX_FILE_SIZE" value="'.$picture_size.'" />
       '.__('Select images to upload').': <input name="picload" type="file"/><br />
    <input type="submit" value="'.__('Upload images').'" />
</form>';
return $form;
}

?>